Loading...
1#!/bin/bash
2# SPDX-License-Identifier: GPL-2.0
3# (c) 2014, Sasha Levin <sasha.levin@oracle.com>
4#set -x
5
6usage() {
7 echo "Usage:"
8 echo " $0 -r <release> | <vmlinux> [<base path>|auto] [<modules path>]"
9}
10
11# Try to find a Rust demangler
12if type llvm-cxxfilt >/dev/null 2>&1 ; then
13 cppfilt=llvm-cxxfilt
14elif type c++filt >/dev/null 2>&1 ; then
15 cppfilt=c++filt
16 cppfilt_opts=-i
17fi
18
19UTIL_SUFFIX=
20if [[ -z ${LLVM:-} ]]; then
21 UTIL_PREFIX=${CROSS_COMPILE:-}
22else
23 UTIL_PREFIX=llvm-
24 if [[ ${LLVM} == */ ]]; then
25 UTIL_PREFIX=${LLVM}${UTIL_PREFIX}
26 elif [[ ${LLVM} == -* ]]; then
27 UTIL_SUFFIX=${LLVM}
28 fi
29fi
30
31READELF=${UTIL_PREFIX}readelf${UTIL_SUFFIX}
32ADDR2LINE=${UTIL_PREFIX}addr2line${UTIL_SUFFIX}
33
34if [[ $1 == "-r" ]] ; then
35 vmlinux=""
36 basepath="auto"
37 modpath=""
38 release=$2
39
40 for fn in {,/usr/lib/debug}/boot/vmlinux-$release{,.debug} /lib/modules/$release{,/build}/vmlinux ; do
41 if [ -e "$fn" ] ; then
42 vmlinux=$fn
43 break
44 fi
45 done
46
47 if [[ $vmlinux == "" ]] ; then
48 echo "ERROR! vmlinux image for release $release is not found" >&2
49 usage
50 exit 2
51 fi
52else
53 vmlinux=$1
54 basepath=${2-auto}
55 modpath=$3
56 release=""
57 debuginfod=
58
59 # Can we use debuginfod-find?
60 if type debuginfod-find >/dev/null 2>&1 ; then
61 debuginfod=${1-only}
62 fi
63
64 if [[ $vmlinux == "" && -z $debuginfod ]] ; then
65 echo "ERROR! vmlinux image must be specified" >&2
66 usage
67 exit 1
68 fi
69fi
70
71declare aarray_support=true
72declare -A cache 2>/dev/null
73if [[ $? != 0 ]]; then
74 aarray_support=false
75else
76 declare -A modcache
77fi
78
79find_module() {
80 if [[ -n $debuginfod ]] ; then
81 if [[ -n $modbuildid ]] ; then
82 debuginfod-find debuginfo $modbuildid && return
83 fi
84
85 # Only using debuginfod so don't try to find vmlinux module path
86 if [[ $debuginfod == "only" ]] ; then
87 return
88 fi
89 fi
90
91 if [[ "$modpath" != "" ]] ; then
92 for fn in $(find "$modpath" -name "${module//_/[-_]}.ko*") ; do
93 if ${READELF} -WS "$fn" | grep -qwF .debug_line ; then
94 echo $fn
95 return
96 fi
97 done
98 return 1
99 fi
100
101 modpath=$(dirname "$vmlinux")
102 find_module && return
103
104 if [[ $release == "" ]] ; then
105 release=$(gdb -ex 'print init_uts_ns.name.release' -ex 'quit' -quiet -batch "$vmlinux" 2>/dev/null | sed -n 's/\$1 = "\(.*\)".*/\1/p')
106 fi
107
108 for dn in {/usr/lib/debug,}/lib/modules/$release ; do
109 if [ -e "$dn" ] ; then
110 modpath="$dn"
111 find_module && return
112 fi
113 done
114
115 modpath=""
116 return 1
117}
118
119parse_symbol() {
120 # The structure of symbol at this point is:
121 # ([name]+[offset]/[total length])
122 #
123 # For example:
124 # do_basic_setup+0x9c/0xbf
125
126 if [[ $module == "" ]] ; then
127 local objfile=$vmlinux
128 elif [[ $aarray_support == true && "${modcache[$module]+isset}" == "isset" ]]; then
129 local objfile=${modcache[$module]}
130 else
131 local objfile=$(find_module)
132 if [[ $objfile == "" ]] ; then
133 echo "WARNING! Modules path isn't set, but is needed to parse this symbol" >&2
134 return
135 fi
136 if [[ $aarray_support == true ]]; then
137 modcache[$module]=$objfile
138 fi
139 fi
140
141 # Remove the englobing parenthesis
142 symbol=${symbol#\(}
143 symbol=${symbol%\)}
144
145 # Strip segment
146 local segment
147 if [[ $symbol == *:* ]] ; then
148 segment=${symbol%%:*}:
149 symbol=${symbol#*:}
150 fi
151
152 # Strip the symbol name so that we could look it up
153 local name=${symbol%+*}
154
155 # Use 'nm vmlinux' to figure out the base address of said symbol.
156 # It's actually faster to call it every time than to load it
157 # all into bash.
158 if [[ $aarray_support == true && "${cache[$module,$name]+isset}" == "isset" ]]; then
159 local base_addr=${cache[$module,$name]}
160 else
161 local base_addr=$(nm "$objfile" 2>/dev/null | awk '$3 == "'$name'" && ($2 == "t" || $2 == "T") {print $1; exit}')
162 if [[ $base_addr == "" ]] ; then
163 # address not found
164 return
165 fi
166 if [[ $aarray_support == true ]]; then
167 cache[$module,$name]="$base_addr"
168 fi
169 fi
170 # Let's start doing the math to get the exact address into the
171 # symbol. First, strip out the symbol total length.
172 local expr=${symbol%/*}
173
174 # Now, replace the symbol name with the base address we found
175 # before.
176 expr=${expr/$name/0x$base_addr}
177
178 # Evaluate it to find the actual address
179 expr=$((expr))
180 local address=$(printf "%x\n" "$expr")
181
182 # Pass it to addr2line to get filename and line number
183 # Could get more than one result
184 if [[ $aarray_support == true && "${cache[$module,$address]+isset}" == "isset" ]]; then
185 local code=${cache[$module,$address]}
186 else
187 local code=$(${ADDR2LINE} -i -e "$objfile" "$address" 2>/dev/null)
188 if [[ $aarray_support == true ]]; then
189 cache[$module,$address]=$code
190 fi
191 fi
192
193 # addr2line doesn't return a proper error code if it fails, so
194 # we detect it using the value it prints so that we could preserve
195 # the offset/size into the function and bail out
196 if [[ $code == "??:0" ]]; then
197 return
198 fi
199
200 # Strip out the base of the path on each line
201 code=$(while read -r line; do echo "${line#$basepath/}"; done <<< "$code")
202
203 # In the case of inlines, move everything to same line
204 code=${code//$'\n'/' '}
205
206 # Demangle if the name looks like a Rust symbol and if
207 # we got a Rust demangler
208 if [[ $name =~ ^_R && $cppfilt != "" ]] ; then
209 name=$("$cppfilt" "$cppfilt_opts" "$name")
210 fi
211
212 # Replace old address with pretty line numbers
213 symbol="$segment$name ($code)"
214}
215
216debuginfod_get_vmlinux() {
217 local vmlinux_buildid=${1##* }
218
219 if [[ $vmlinux != "" ]]; then
220 return
221 fi
222
223 if [[ $vmlinux_buildid =~ ^[0-9a-f]+ ]]; then
224 vmlinux=$(debuginfod-find debuginfo $vmlinux_buildid)
225 if [[ $? -ne 0 ]] ; then
226 echo "ERROR! vmlinux image not found via debuginfod-find" >&2
227 usage
228 exit 2
229 fi
230 return
231 fi
232 echo "ERROR! Build ID for vmlinux not found. Try passing -r or specifying vmlinux" >&2
233 usage
234 exit 2
235}
236
237decode_code() {
238 local scripts=`dirname "${BASH_SOURCE[0]}"`
239
240 echo "$1" | $scripts/decodecode
241}
242
243handle_line() {
244 if [[ $basepath == "auto" && $vmlinux != "" ]] ; then
245 module=""
246 symbol="kernel_init+0x0/0x0"
247 parse_symbol
248 basepath=${symbol#kernel_init (}
249 basepath=${basepath%/init/main.c:*)}
250 fi
251
252 local words
253
254 # Tokenize
255 read -a words <<<"$1"
256
257 # Remove hex numbers. Do it ourselves until it happens in the
258 # kernel
259
260 # We need to know the index of the last element before we
261 # remove elements because arrays are sparse
262 local last=$(( ${#words[@]} - 1 ))
263
264 for i in "${!words[@]}"; do
265 # Remove the address
266 if [[ ${words[$i]} =~ \[\<([^]]+)\>\] ]]; then
267 unset words[$i]
268 fi
269
270 # Format timestamps with tabs
271 if [[ ${words[$i]} == \[ && ${words[$i+1]} == *\] ]]; then
272 unset words[$i]
273 words[$i+1]=$(printf "[%13s\n" "${words[$i+1]}")
274 fi
275 done
276
277 if [[ ${words[$last]} =~ ^[0-9a-f]+\] ]]; then
278 words[$last-1]="${words[$last-1]} ${words[$last]}"
279 unset words[$last]
280 last=$(( $last - 1 ))
281 fi
282
283 if [[ ${words[$last]} =~ \[([^]]+)\] ]]; then
284 module=${words[$last]}
285 module=${module#\[}
286 module=${module%\]}
287 modbuildid=${module#* }
288 module=${module% *}
289 if [[ $modbuildid == $module ]]; then
290 modbuildid=
291 fi
292 symbol=${words[$last-1]}
293 unset words[$last-1]
294 else
295 # The symbol is the last element, process it
296 symbol=${words[$last]}
297 module=
298 modbuildid=
299 fi
300
301 unset words[$last]
302 parse_symbol # modifies $symbol
303
304 # Add up the line number to the symbol
305 echo "${words[@]}" "$symbol $module"
306}
307
308while read line; do
309 # Strip unexpected carriage return at end of line
310 line=${line%$'\r'}
311
312 # Let's see if we have an address in the line
313 if [[ $line =~ \[\<([^]]+)\>\] ]] ||
314 [[ $line =~ [^+\ ]+\+0x[0-9a-f]+/0x[0-9a-f]+ ]]; then
315 # Translate address to line numbers
316 handle_line "$line"
317 # Is it a code line?
318 elif [[ $line == *Code:* ]]; then
319 decode_code "$line"
320 # Is it a version line?
321 elif [[ -n $debuginfod && $line =~ PID:\ [0-9]+\ Comm: ]]; then
322 debuginfod_get_vmlinux "$line"
323 else
324 # Nothing special in this line, show it as is
325 echo "$line"
326 fi
327done
1#!/usr/bin/env bash
2# SPDX-License-Identifier: GPL-2.0
3# (c) 2014, Sasha Levin <sasha.levin@oracle.com>
4#set -x
5
6usage() {
7 echo "Usage:"
8 echo " $0 -r <release>"
9 echo " $0 [<vmlinux> [<base_path>|auto [<modules_path>]]]"
10 echo " $0 -h"
11}
12
13# Try to find a Rust demangler
14if type llvm-cxxfilt >/dev/null 2>&1 ; then
15 cppfilt=llvm-cxxfilt
16elif type c++filt >/dev/null 2>&1 ; then
17 cppfilt=c++filt
18 cppfilt_opts=-i
19fi
20
21UTIL_SUFFIX=
22if [[ -z ${LLVM:-} ]]; then
23 UTIL_PREFIX=${CROSS_COMPILE:-}
24else
25 UTIL_PREFIX=llvm-
26 if [[ ${LLVM} == */ ]]; then
27 UTIL_PREFIX=${LLVM}${UTIL_PREFIX}
28 elif [[ ${LLVM} == -* ]]; then
29 UTIL_SUFFIX=${LLVM}
30 fi
31fi
32
33READELF=${UTIL_PREFIX}readelf${UTIL_SUFFIX}
34ADDR2LINE=${UTIL_PREFIX}addr2line${UTIL_SUFFIX}
35NM=${UTIL_PREFIX}nm${UTIL_SUFFIX}
36
37if [[ $1 == "-h" ]] ; then
38 usage
39 exit 0
40elif [[ $1 == "-r" ]] ; then
41 vmlinux=""
42 basepath="auto"
43 modpath=""
44 release=$2
45
46 for fn in {,/usr/lib/debug}/boot/vmlinux-$release{,.debug} /lib/modules/$release{,/build}/vmlinux ; do
47 if [ -e "$fn" ] ; then
48 vmlinux=$fn
49 break
50 fi
51 done
52
53 if [[ $vmlinux == "" ]] ; then
54 echo "ERROR! vmlinux image for release $release is not found" >&2
55 usage
56 exit 2
57 fi
58else
59 vmlinux=$1
60 basepath=${2-auto}
61 modpath=$3
62 release=""
63 debuginfod=
64
65 # Can we use debuginfod-find?
66 if type debuginfod-find >/dev/null 2>&1 ; then
67 debuginfod=${1-only}
68 fi
69
70 if [[ $vmlinux == "" && -z $debuginfod ]] ; then
71 echo "ERROR! vmlinux image must be specified" >&2
72 usage
73 exit 1
74 fi
75fi
76
77declare aarray_support=true
78declare -A cache 2>/dev/null
79if [[ $? != 0 ]]; then
80 aarray_support=false
81else
82 declare -A modcache
83fi
84
85find_module() {
86 if [[ -n $debuginfod ]] ; then
87 if [[ -n $modbuildid ]] ; then
88 debuginfod-find debuginfo $modbuildid && return
89 fi
90
91 # Only using debuginfod so don't try to find vmlinux module path
92 if [[ $debuginfod == "only" ]] ; then
93 return
94 fi
95 fi
96
97 if [ -z $release ] ; then
98 release=$(gdb -ex 'print init_uts_ns.name.release' -ex 'quit' -quiet -batch "$vmlinux" 2>/dev/null | sed -n 's/\$1 = "\(.*\)".*/\1/p')
99 fi
100 if [ -n "${release}" ] ; then
101 release_dirs="/usr/lib/debug/lib/modules/$release /lib/modules/$release"
102 fi
103
104 found_without_debug_info=false
105 for dir in "$modpath" "$(dirname "$vmlinux")" ${release_dirs}; do
106 if [ -n "${dir}" ] && [ -e "${dir}" ]; then
107 for fn in $(find "$dir" -name "${module//_/[-_]}.ko*") ; do
108 if ${READELF} -WS "$fn" | grep -qwF .debug_line ; then
109 echo $fn
110 return
111 fi
112 found_without_debug_info=true
113 done
114 fi
115 done
116
117 if [[ ${found_without_debug_info} == true ]]; then
118 echo "WARNING! No debugging info in module ${module}, rebuild with DEBUG_KERNEL and DEBUG_INFO" >&2
119 else
120 echo "WARNING! Cannot find .ko for module ${module}, please pass a valid module path" >&2
121 fi
122
123 return 1
124}
125
126parse_symbol() {
127 # The structure of symbol at this point is:
128 # ([name]+[offset]/[total length])
129 #
130 # For example:
131 # do_basic_setup+0x9c/0xbf
132
133 if [[ $module == "" ]] ; then
134 local objfile=$vmlinux
135 elif [[ $aarray_support == true && "${modcache[$module]+isset}" == "isset" ]]; then
136 local objfile=${modcache[$module]}
137 else
138 local objfile=$(find_module)
139 if [[ $objfile == "" ]] ; then
140 return
141 fi
142 if [[ $aarray_support == true ]]; then
143 modcache[$module]=$objfile
144 fi
145 fi
146
147 # Remove the englobing parenthesis
148 symbol=${symbol#\(}
149 symbol=${symbol%\)}
150
151 # Strip segment
152 local segment
153 if [[ $symbol == *:* ]] ; then
154 segment=${symbol%%:*}:
155 symbol=${symbol#*:}
156 fi
157
158 # Strip the symbol name so that we could look it up
159 local name=${symbol%+*}
160
161 # Use 'nm vmlinux' to figure out the base address of said symbol.
162 # It's actually faster to call it every time than to load it
163 # all into bash.
164 if [[ $aarray_support == true && "${cache[$module,$name]+isset}" == "isset" ]]; then
165 local base_addr=${cache[$module,$name]}
166 else
167 local base_addr=$(${NM} "$objfile" 2>/dev/null | awk '$3 == "'$name'" && ($2 == "t" || $2 == "T") {print $1; exit}')
168 if [[ $base_addr == "" ]] ; then
169 # address not found
170 return
171 fi
172 if [[ $aarray_support == true ]]; then
173 cache[$module,$name]="$base_addr"
174 fi
175 fi
176 # Let's start doing the math to get the exact address into the
177 # symbol. First, strip out the symbol total length.
178 local expr=${symbol%/*}
179
180 # Now, replace the symbol name with the base address we found
181 # before.
182 expr=${expr/$name/0x$base_addr}
183
184 # Evaluate it to find the actual address
185 expr=$((expr))
186 local address=$(printf "%x\n" "$expr")
187
188 # Pass it to addr2line to get filename and line number
189 # Could get more than one result
190 if [[ $aarray_support == true && "${cache[$module,$address]+isset}" == "isset" ]]; then
191 local code=${cache[$module,$address]}
192 else
193 local code=$(${ADDR2LINE} -i -e "$objfile" "$address" 2>/dev/null)
194 if [[ $aarray_support == true ]]; then
195 cache[$module,$address]=$code
196 fi
197 fi
198
199 # addr2line doesn't return a proper error code if it fails, so
200 # we detect it using the value it prints so that we could preserve
201 # the offset/size into the function and bail out
202 if [[ $code == "??:0" ]]; then
203 return
204 fi
205
206 # Strip out the base of the path on each line
207 code=$(while read -r line; do echo "${line#$basepath/}"; done <<< "$code")
208
209 # In the case of inlines, move everything to same line
210 code=${code//$'\n'/' '}
211
212 # Demangle if the name looks like a Rust symbol and if
213 # we got a Rust demangler
214 if [[ $name =~ ^_R && $cppfilt != "" ]] ; then
215 name=$("$cppfilt" "$cppfilt_opts" "$name")
216 fi
217
218 # Replace old address with pretty line numbers
219 symbol="$segment$name ($code)"
220}
221
222debuginfod_get_vmlinux() {
223 local vmlinux_buildid=${1##* }
224
225 if [[ $vmlinux != "" ]]; then
226 return
227 fi
228
229 if [[ $vmlinux_buildid =~ ^[0-9a-f]+ ]]; then
230 vmlinux=$(debuginfod-find debuginfo $vmlinux_buildid)
231 if [[ $? -ne 0 ]] ; then
232 echo "ERROR! vmlinux image not found via debuginfod-find" >&2
233 usage
234 exit 2
235 fi
236 return
237 fi
238 echo "ERROR! Build ID for vmlinux not found. Try passing -r or specifying vmlinux" >&2
239 usage
240 exit 2
241}
242
243decode_code() {
244 local scripts=`dirname "${BASH_SOURCE[0]}"`
245
246 echo "$1" | $scripts/decodecode
247}
248
249handle_line() {
250 if [[ $basepath == "auto" && $vmlinux != "" ]] ; then
251 module=""
252 symbol="kernel_init+0x0/0x0"
253 parse_symbol
254 basepath=${symbol#kernel_init (}
255 basepath=${basepath%/init/main.c:*)}
256 fi
257
258 local words
259
260 # Tokenize
261 read -a words <<<"$1"
262
263 # Remove hex numbers. Do it ourselves until it happens in the
264 # kernel
265
266 # We need to know the index of the last element before we
267 # remove elements because arrays are sparse
268 local last=$(( ${#words[@]} - 1 ))
269
270 for i in "${!words[@]}"; do
271 # Remove the address
272 if [[ ${words[$i]} =~ \[\<([^]]+)\>\] ]]; then
273 unset words[$i]
274 fi
275
276 # Format timestamps with tabs
277 if [[ ${words[$i]} == \[ && ${words[$i+1]} == *\] ]]; then
278 unset words[$i]
279 words[$i+1]=$(printf "[%13s\n" "${words[$i+1]}")
280 fi
281 done
282
283 if [[ ${words[$last]} =~ ^[0-9a-f]+\] ]]; then
284 words[$last-1]="${words[$last-1]} ${words[$last]}"
285 unset words[$last]
286 last=$(( $last - 1 ))
287 fi
288
289 # Extract info after the symbol if present. E.g.:
290 # func_name+0x54/0x80 (P)
291 # ^^^
292 # The regex assumes only uppercase letters will be used. To be
293 # extended if needed.
294 local info_str=""
295 if [[ ${words[$last]} =~ \([A-Z]*\) ]]; then
296 info_str=${words[$last]}
297 unset words[$last]
298 last=$(( $last - 1 ))
299 fi
300
301 if [[ ${words[$last]} =~ \[([^]]+)\] ]]; then
302 module=${words[$last]}
303 # some traces format is "(%pS)", which like "(foo+0x0/0x1 [bar])"
304 # so $module may like "[bar])". Strip the right parenthesis firstly
305 module=${module%\)}
306 module=${module#\[}
307 module=${module%\]}
308 modbuildid=${module#* }
309 module=${module% *}
310 if [[ $modbuildid == $module ]]; then
311 modbuildid=
312 fi
313 symbol=${words[$last-1]}
314 unset words[$last-1]
315 else
316 # The symbol is the last element, process it
317 symbol=${words[$last]}
318 module=
319 modbuildid=
320 fi
321
322 unset words[$last]
323 parse_symbol # modifies $symbol
324
325 # Add up the line number to the symbol
326 if [[ -z ${module} ]]
327 then
328 echo "${words[@]}" "$symbol ${info_str}"
329 else
330 echo "${words[@]}" "$symbol $module ${info_str}"
331 fi
332}
333
334while read line; do
335 # Strip unexpected carriage return at end of line
336 line=${line%$'\r'}
337
338 # Let's see if we have an address in the line
339 if [[ $line =~ \[\<([^]]+)\>\] ]] ||
340 [[ $line =~ [^+\ ]+\+0x[0-9a-f]+/0x[0-9a-f]+ ]]; then
341 # Translate address to line numbers
342 handle_line "$line"
343 # Is it a code line?
344 elif [[ $line == *Code:* ]]; then
345 decode_code "$line"
346 # Is it a version line?
347 elif [[ -n $debuginfod && $line =~ PID:\ [0-9]+\ Comm: ]]; then
348 debuginfod_get_vmlinux "$line"
349 else
350 # Nothing special in this line, show it as is
351 echo "$line"
352 fi
353done